/* Problem URL: https://codeforces.com/contest/1913/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vl fds(n);
        cin >> fds;

        stack<pair<int, int>> s;

        vi left(n, 0);
        vi right(n, n - 1);

        rep(i, n) {
            while (!s.empty() && s.top().first > fds[i]) {
                s.pop();
            }

            if (s.empty()) {
                s.emplace(fds[i], i + 1);
                continue;
            }

            left[i] = s.top().second;
            s.emplace(fds[i], i);
        }

        s = stack<pair<int, int>>();

        for (int i = n - 1; i >= 0; i--) {
            while (!s.empty() && s.top().first > fds[i]) {
                s.pop();
            }

            if (s.empty()) {
                s.emplace(fds[i], i - 1);
                continue;
            }

            right[i] = s.top().second;
            s.emplace(fds[i], i);
        }

        vl dp1(n + 1);
        dp1[0] = 1;

        vl dp2(n + 1);
        dp2[n] = 1;

        const ll mod = 998244353;

        rep(i, n) {
            if (left[i] > 0) {
                dp1[i + 1] += dp1[i];
                continue;
            }

            dp1[i + 1] = (dp1[i] + i) % mod;
        }

        for (int i = n - 1; i >= 0; i--) {
            if (right[i] < n - 1) {
                dp2[i] += dp2[i + 1];
                continue;
            }

            dp2[i] = (dp2[i] + (n - i + 1)) % mod;
        }

        cout << dp1[n] + dp2[0] << '\n';
    }
}
